﻿citModule.controller('CitImportAssetListController', ['$scope', '$log', '$translate', '$timeout', '$compile', '$uibModal', 'apiInterceptor', 'Upload',
    'assetListService', 'SweetAlert', '$q', 'uiGridConstants', '$interval', 'vatSessionService', 'citSessionService', 'vatImportService', 'loginContext',
    'browserService', 'enums', 'vatOperationLogService', 'projectService', 'vatCommonService', 'ackMessageBox',
    function ($scope, $log, $translate, $timeout, $compile, $uibModal, apiInterceptor, Upload, assetListService, SweetAlert, $q, uiGridConstants,
              $interval, vatSessionService, citSessionService, vatImportService, loginContext, browserService, enums, vatOperationLogService, projectService,
              vatCommonService, ackMessageBox) {
        'use strict';

        var projectId = vatSessionService.project.id;
        var successCount = 0;
        var uploadUrl = apiInterceptor.webApiHostUrl + '/asset/assetsImport';
        var webHost = loginContext.apiHost;
        var chunkSize = 100000;
        var resumable = true;
        var curYear = vatSessionService.project.year;
        var comment = vatSessionService.project.name + " " + vatSessionService.project.year + "年";
        var projectDbName = vatSessionService.project.dbName;
        var serviceErrorMsg = $translate.instant('PleaseContactAdministrator');
        var targetArray = [];

        //写日志
        $scope.moduleid = enums.vatModuleEnum.Import_AssetDiffData;
        var logDto = {
            ID: '',
            OperationName: '',
            ModuleID: $scope.moduleid,
            OperationObject: $translate.instant('AssetListImport'),
            OperationType: '',
            OperationContent: '',
            OriginalState: '',
            UpdateState: '',
            CreatorID: vatSessionService.logUser.ID,
            Comment: comment,
            IP: '',
            Period: '',
        };

        //分页的设置
        $scope.pagingOptions = {
            pageIndex: 1,  //当前页码
            totalItems: 0,  //总数据
            totalPages: 0,//总页数
            maxSize: 10, //分页数字的限制。
            pageSize: 100,  //每页多少条数据
            pageSizeString: "100",
            pagingSelection: [],
            firstPage: '<<', //$translate.instant('PagingFirstPage'),
            previousPage: '<', //$translate.instant('PagingPreviousPage'),
            nextPage: '>',// $translate.instant('PagingNextPage'),
            lastPage: '>>' //$translate.instant('PagingLastPage'),
        };
//赋值
        $scope.pageOptions = $scope.pagingOptions;
        $scope.hideSelector = $scope.hidePageSizeSelector ? true : false;
        //分页里面的处理
        $scope.pagingService = {
            //分页下拉组装
            populatePagingSelection: function () {
                if($scope.pageOptions.pagingSelection.length==0){
                    var pagingSelection = [];
                    var pageArray = constant.page.pageSizeArrary;
                    for (var i = 0 ; i < pageArray.length; i++) {
                        var selection = { id: pageArray[i], value: pageArray[i] };
                        pagingSelection.push(selection);
                    }
                    $scope.pageOptions.pagingSelection = pagingSelection;
                }
            },

            //分页的时候改变数字
            pageIndexChanging: function () {
                if ($scope.pageOptions.pageIndex > $scope.pageOptions.totalPages) {
                    $scope.pagingOptions.pageIndex = $scope.pageOptions.totalPages;
                }
                if ($scope.pageOptions.pageIndex <= 0) {
                    $scope.pageOptions.pageIndex = 1;
                }

                $log.log('Page changed to: ' + $scope.pageOptions.pageIndex);
                $scope.refreshAssetResultListGrid();
            },

            //每页显示的数据下拉改变
            pageSizeSelectionChanged: function () {
                $scope.pageOptions.pageSize = parseInt($scope.pageOptions.pageSizeString);
                $scope.refreshAssetResultListGrid();
            },
        };

        //导入方式
        $scope.importEnum = {Import: 0, CoverImport: 1, AddImport: 2};
        $scope.sheetData = {sheetNameList: [], dataList: [], selectedSheetIndex: 0};
        $scope.sheetInfo = {selectedSheetName: '', selectedSheetIndex: 0};
        $scope.invoiceData = [];
        $scope.errorMsgMap = [];
        //初始化参数
        $scope.showErrorTable = false;
        $scope.showInitTable = false;
        $scope.showImportTable = false
        $scope.isShowImportTotalBtn = true;
        $scope.SelectAll = false;

        $scope.citAssetsListDto = {
            pageInfo: {
                totalCount: 0,
                pageIndex: 1,
                pageSize: 100,
                totalPage: 0
            },
            assetType: 1,
            projectId: projectId,
            taxAccountCompare: 2,
            assetGroupName: '',
            depreciationPeriod: '',
            taxGroupType: ''
        };
        $scope.refreshAssetResultListGrid = function () {
            $log.debug("refreshAssetResultListGrid");
            getAssetResultList($scope.citAssetsListDto.assetType);
        };
        //初始化列数据
        var initColumns = function () {

            //初始化进项发票汇总表列名
            $scope.incomeInvoiceTotalColumns = [
                $translate.instant('PleaseSelectColumn'),
                $translate.instant('AssetNumber'),
                $translate.instant('AssetGroupName'),
                $translate.instant('AssetDescription'),
                $translate.instant('BuyDate'),
                $translate.instant('DepreciationDate'),
                $translate.instant('DepreciationPeriod'),
                $translate.instant('AcquisitionValue'),
                $translate.instant('AdjustmentValue'),
                $translate.instant('DisposedDate'),
                $translate.instant('ResidualRate'),
                $translate.instant('YearDepreciationAmount'),
                $translate.instant('YearAdjustmentAmount'),
                $translate.instant('YearEndValue'),
                $translate.instant('AssetStatus')
            ];
            $scope.initIncomeInvoiceTotalColumnsIndex = _.range(1, $scope.incomeInvoiceTotalColumns.length);

            //必须进行map的列
            $scope.mustMappingTotalColumns = [
                $translate.instant('AssetNumber'),
                $translate.instant('AssetGroupName'),
                //$translate.instant('AssetDescription'),
                $translate.instant('BuyDate'),
                //$translate.instant('DepreciationDate'),
                $translate.instant('DepreciationPeriod'),
                $translate.instant('AcquisitionValue'),
                //$translate.instant('AdjustmentValue'),
                //$translate.instant('DisposedDate'),
                $translate.instant('ResidualRate'),
                $translate.instant('YearDepreciationAmount'),
                //$translate.instant('YearAdjustmentAmount'),
                $translate.instant('YearEndValue'),
                //$translate.instant('AssetStatus')
            ];
        };

        //上传文件
        var uploadfile = function (file) {

            var url = uploadUrl;

            if (file) {

                successCount = 0;
                if (!file.$error) {
                    var tempFileName = PWC.newGuid() + '.dat';
                    var token = $('input[name="__RequestVerificationToken"]').val();

                    Upload.upload({
                        url: uploadUrl,
                        data: {
                            filename: file.name,
                            tempFileName: tempFileName
                        },
                        file: file,
                        // resumeChunkSize: resumable ? chunkSize : null,
                        headers: {
                            'Access-Control-Allow-Origin': '*',
                            Authorization: apiInterceptor.tokenType + ' ' + apiInterceptor.apiToken(),
                            __RequestVerificationToken: token,
                            withCredentials: true
                        },
                        __RequestVerificationToken: token,
                        withCredentials: true
                    }).then(uploadSuccess).error(function () {
                        SweetAlert('系统内部错误');
                    });
                }
            }
        };

        //上传成功
        var uploadSuccess = function (resp) {

            successCount++;
            if (successCount === 1) {
                $scope.tempFileName = resp.data;
                // changeSheet(0);
            }
        };

        //选择sheet
        function changeSheet(selectedSheet) {
            var sheetIndex = _.findIndex($scope.sheetData.sheetNameList, function (num) {
                return num.name === selectedSheet.name;
            })
            $scope.sheetInfo.selectedSheetIndex = sheetIndex === -1 ? 0 : sheetIndex;
            refreshTable();
        };

        //刷新列表
        function refreshTable() {
            $scope.showErrorTable = false;
            if (_.isString($scope.tempFileName)) {
                $scope.selectedColumnMap = [];
                //$scope.columnNum = 0;
                $scope.sheetData = {sheetNameList: [], dataList: [], selectedSheetIndex: 0};
                vatImportService.getFileContent($scope.tempFileName, $scope.sheetInfo.selectedSheetIndex, 0).success(function (data) {
                    if (data.result === false) {
                        $scope.showInitTable = true;
                        $scope.showImportTable = false;
                        //initTableTitle();
                        SweetAlert.warning(data.resultMsg);
                    } else {
                        $scope.showInitTable = false;
                        $scope.showImportTable = true
                    }
                    $scope.sheetData = data;
                    var sheetNameObjectArray = [];
                    data.sheetNameList.forEach(function (v) {
                        sheetNameObjectArray.push({'name': v});
                    });
                    $scope.sheetData.sheetNameList = sheetNameObjectArray;
                    $scope.sheetInfo.selectedSheetName = $scope.sheetData.sheetNameList[$scope.sheetInfo.selectedSheetIndex];
                    citSessionService.dataChanged = true;
                    $scope.invoiceData = $scope.sheetData.dataList.slice(0, $scope.sheetData.dataList.length);
                    initColumns();
                    //加入index序号
                    var index = 1;
                    $scope.invoiceData.forEach(function (v) {
                        v.index = index++;
                    });
                }).error(function () {
                    SweetAlert.error(serviceErrorMsg);
                });
            }
        };

        //简易导入,importType来分辨是覆盖导入还是追加导入
        $scope.importDataNew = function (importType) {
            if (!$scope.file || !$scope.file.name) {

                SweetAlert.warning($translate.instant('SelectImportFileRequired'));
                return;
            }

            var tempFileName = PWC.newGuid() + '.dat';

            var token = $('input[name="__RequestVerificationToken"]').val();
            // updateProgressToZero();
            $('#busy-indicator-container').show();
            Upload.upload({
                url: uploadUrl,
                data: {
                    filename: $scope.file.name,
                    tempFileName: tempFileName,
                    projectId: projectId,
                    importType: importType
                },
                file: $scope.file,
                resumeChunkSize: resumable ? $scope.chunkSize : null,
                headers: {
                    'Access-Control-Allow-Origin': '*',
                    Authorization: apiInterceptor.tokenType + ' ' + apiInterceptor.apiToken(),
                    __RequestVerificationToken: token,
                    withCredentials: true
                }, withCredentials: true
            }).success(function (resp) {
                $('#busy-indicator-container').hide();

                if (resp.code == 1) {
                    assetListService.getAssetGroupResultData(projectId).success(function (groupResultData) {
                        $scope.assetGroupResultDataSource = groupResultData.data;
                    });
                    // $scope.assetGroupResultDataSource = resp.data;
                    InitGrid(false);
                    $scope.saveGroupType = 1;
                    $scope.isDisabled = true;
                    //为方便开发暂时先改为false
                    $scope.isDisabled = false;
                    $scope.modalInstance = $uibModal.open({
                        animation: false,
                        backdrop: 'static',
                        keyboard: false,
                        ariaLabelledBy: 'modal-title',
                        ariaDescribedBy: 'modal-body',
                        templateUrl: 'set-asset-group-modal.html',
                        scope: $scope,
                        windowClass: "set-asset-list-modal"
                    });
                } else {
                    SweetAlert.error("文件导入出现错误，请重试");
                }

            }).error(function (resp) {
                SweetAlert.error("文件导入出现错误，请重试");
            });
        };

        //根据分类获取数据
        function getAssetResultList(assetType) {
            debugger;
            $scope.citAssetsListDto.assetType = assetType;
            $scope.citAssetsListDto.pageInfo = {
                pageIndex: $scope.pagingOptions.pageIndex,
                totalItems: $scope.pagingOptions.totalItems,
                pageSize: $scope.pagingOptions.pageSize
            };
            $scope.TotalCount = 0;
            $scope.TotalAccountAcquisitionValue = 0;
            $scope.TotalAccountYearDepreciationAmount = 0;
            $scope.TotalTaxCurrentYearDepreciationAmount = 0;
            $scope.TotalYearDifferenceAmount = 0;
            assetListService.getAssetResultListPage($scope.citAssetsListDto).success(function (assetListData) {
                debugger;
                var data = assetListData.data.list;
                $('.filter-button').popover("hide");
                if (data) {
                    var index = 1;
                    // data.forEach(function (v) {
                    //     v.index = index++;
                    //     $scope.TotalAccountAcquisitionValue += v.accountAcquisitionValue;
                    //     $scope.TotalAccountYearDepreciationAmount += v.accountYearDepreciationAmount;
                    //     $scope.TotalTaxCurrentYearDepreciationAmount += v.taxCurrentYearDepreciationAmount;
                    //     if(v.isRetain == 1){
                    //         $scope.TotalYearDifferenceAmount += v.yearDifferenceAmount;
                    //     }
                    // });
                    $scope.assetsResultData = data;

                    // $scope.TotalAccountAcquisitionValue = PWC.round($scope.TotalAccountAcquisitionValue, 2);
                    // $scope.TotalAccountYearDepreciationAmount = PWC.round($scope.TotalAccountYearDepreciationAmount, 2);
                    // $scope.TotalTaxCurrentYearDepreciationAmount = PWC.round($scope.TotalTaxCurrentYearDepreciationAmount, 2);
                    // $scope.TotalYearDifferenceAmount = PWC.round($scope.TotalYearDifferenceAmount, 2);
                    $scope.TotalAccountAcquisitionValue = PWC.round(data[0].totalAccountAcquisitionValue, 2);
                    $scope.TotalAccountYearDepreciationAmount = PWC.round(data[0].totalAccountYearDepreciationAmount, 2);
                    $scope.TotalTaxCurrentYearDepreciationAmount = PWC.round(data[0].totalTaxCurrentYearDepreciationAmount, 2);
                    $scope.TotalYearDifferenceAmount = PWC.round(data[0].totalYearDifferenceAmount, 2);
                }
                $scope.TotalCount = assetListData.data.total;
                $scope.pagingOptions.totalItems = assetListData.data.total;
                $scope.pageOptions.totalItems = assetListData.data.total;

            });
        }

        function setErrorWrapCssDefault() {
            $('#content-resizer').css('bottom', '10px');

            $('#topIcon').css({bottom: '-501px'});

            $('.error-info-wrapper').css('height', '0px');
        };

        function showErrTab() {
            $scope.ImportErrorTab = true;
            $scope.ImportErrorTag = true;
            $scope.errorMsg = $translate.instant('ImportAssetErrorMsg').formatObj({"NumberOfError": $scope.errorList.length});

        };

        //显示明细
        var dealDetail = function () {
            return '<div ng-if="row.entity.isShowDetail === 1" class="ui-grid-cell-contents"><span><a  ng-click="grid.appScope.openTab(row.entity.erpCheckTypeId,row.entity.validationDetails)">查看明细</a><span></div>' +
                '<div  ng-if="row.entity.isShowDetail !== 1" class="ui-grid-cell-contents" title="{{row.entity.validationDetails}}"><span>{{row.entity.validationDetails}}<span></div>';
        }

        //初始化dx控件
        function initDxGrid() {
            var dupColumns = [
                {caption: $translate.instant('ImportErrorPopUpNoCol'), dataField: "index", width: 50},
                {caption: $translate.instant('AssetNumber'), dataField: "assetNumber"},
                {caption: $translate.instant('AssetGroupName'), dataField: "assetGroupName",},
                {caption: $translate.instant('AssetDescription'), dataField: "assetDescription",},
                {caption: $translate.instant('BuyDate'), dataField: "buyDate", dataType: "date", format: "yyyy-MM-dd",},
                {
                    caption: $translate.instant('DepreciationDate'),
                    dataField: "depreciationDate",
                    dataType: "date",
                    format: "yyyy-MM-dd",
                },
                {
                    caption: $translate.instant('DepreciationPeriod'),
                    dataField: "depreciationPeriod",
                    format: {type: 'fixedPoint', precision: 0}
                },
                {
                    caption: $translate.instant('AcquisitionValue'),
                    dataField: "acquisitionValue",
                    format: {type: 'fixedPoint', precision: 2}
                },
                {
                    caption: $translate.instant('AdjustmentValue'),
                    dataField: "adjustmentValue",
                    format: {type: 'fixedPoint', precision: 2}
                },
                {
                    caption: $translate.instant('DisposedDate'),
                    dataField: "disposedDate",
                    dataType: "date",
                    format: "yyyy-MM-dd",
                },
                {
                    caption: $translate.instant('ResidualRate'),
                    dataField: "residualRate",
                    format: {type: 'fixedPoint', precision: 2}
                },
                {
                    caption: $translate.instant('YearDepreciationAmount'),
                    dataField: "yearDepreciationAmount",
                    format: {type: 'fixedPoint', precision: 2}
                },
                {
                    caption: $translate.instant('YearAdjustmentAmount'),
                    dataField: "yearAdjustmentAmount",
                    format: {type: 'fixedPoint', precision: 2}
                },
                {
                    caption: $translate.instant('YearEndValue'),
                    dataField: "yearEndValue",
                    format: {type: 'fixedPoint', precision: 2}
                },
            ];

            $scope.gridInitDataOption = {
                columns: dupColumns,
                bindingOptions: {
                    "dataSource": "assetDBData"
                },
                onInitialized: function (e) {
                    $scope.assetImportGridInstance = e.component;
                },
                hoverStateEnabled: true,
                scrolling: {mode: "virtual"},
                noDataText: $translate.instant('AccountVoucher_DataGrid_NoDataText'),
                height: '99%',
            }
        }

        //初始化编辑d资产分类（asset_group_result）ataGrid
        var InitGrid = function (showAdd) {
            $scope.assetsGridOptions = {
                bindingOptions: {
                    dataSource: 'assetGroupResultDataSource',
                },
                keyExpr: "id",
                paging: {
                    enabled: false
                },
                editing: {
                    mode: "batch",
                    allowUpdating: true,
                },
                onInitialized: function (e) {
                    $scope.assetGroupGridInstance = e.component;
                },
                showBorders: true,
                hoverStateEnabled: true,
                onCellPrepared: function (e) {
                    if (e.rowType === "header" && PWC.isNullOrEmpty(e.column.caption)) {
                        e.cellElement.empty();
                        e.cellElement.append("操作");
                        e.cellElement.addClass('herder-center');
                    }
                    if (e.rowType === "data" && e.column.command === "edit") {
                        var isEditing = e.row.isEditing,
                            $links = e.cellElement.find(".dx-link");
                        if (isEditing) {
                            $links.filter(".dx-link-save").addClass("column-color");
                            $links.filter(".dx-link-cancel").addClass("column-color");
                        } else {
                            $links.filter(".dx-link-edit").addClass("column-color");
                            $links.filter(".dx-link-delete").addClass("column-color");
                        }
                    }
                },
                columns: [
                    {
                        caption: $translate.instant('ImportErrorPopUpNoCol'),
                        dataField: "index",
                        width: 50,
                        allowEditing: false,

                    },
                    {
                        caption: $translate.instant('AssetGroupName'),
                        dataField: "assetName",
                        width: 150,
                        allowEditing: false,
                    },
                    {
                        caption: $translate.instant('LevelOneGroup'), dataField: "assetGroupId",
                        validationRules: [{
                            type: "required",
                            message: $translate.instant('LevelOneGroupValidation')
                        }],
                        setCellValue: function (rowData, value) {
                            rowData.assetGroupId = value;

                            var aseetDetailList = _.filter($scope.detailGroupListDataSource, function (item) {
                                return item.assetGroupId == value;
                            });
                            if (aseetDetailList.length == 0) {
                                rowData.assetDetailGroupId = null;
                                rowData.taxDepreciationPeriod = null;
                            } else {
                                rowData.assetDetailGroupId = aseetDetailList[0].id;
                                rowData.taxDepreciationPeriod = aseetDetailList[0].groupYear * 12;
                            }
                            ;
                        },
                        lookup: {
                            dataSource: $scope.groupListDataSource,
                            displayExpr: "assetGroupName",
                            valueExpr: "id"
                        }
                    },
                    {
                        caption: $translate.instant('LevelTwoGroup'), dataField: "assetDetailGroupId",
                        validationRules: [{
                            type: "required",
                            message: $translate.instant('LevelTwoGroupValidation')
                        }],
                        setCellValue: function (rowData, value) {
                            rowData.assetDetailGroupId = value;

                            var aseetDetailList = _.filter($scope.detailGroupListDataSource, function (item) {
                                return item.id == value;
                                return item.id == value;
                            });
                            if (aseetDetailList.length > 0) {
                                rowData.taxDepreciationPeriod = aseetDetailList[0].groupYear * 12;
                            }
                        },
                        lookup: {
                            dataSource: function (options) {

                                return {
                                    store: $scope.detailGroupListDataSource,
                                    filter: options.data ? ["assetGroupId", "=", options.data.assetGroupId] : null
                                };
                            },
                            displayExpr: "detailGroupName",
                            valueExpr: "id"
                        }
                    },
                    {
                        caption: $translate.instant('DepreciationPeriod'),
                        dataField: "taxDepreciationPeriod",
                        width: 100,
                        validationRules: [{
                            type: "required",
                            message: $translate.instant('DepreciationPeriodValidation')
                        }],
                    }
                ],
                width: '99%',
                onToolbarPreparing: function (e) {
                    var toolbarItems = e.toolbarOptions.items;
                    _.each(toolbarItems, function (item) {
                        if (item.name === 'saveButton' || item.name == 'revertButton') {
                            item.visible = false;
                        }
                    });
                }
            };
        }

        //初始化dx控件
        function initAssetResultDxGrid() {

            var dupColumns = [
                {
                    caption: $translate.instant('ImportErrorPopUpNoCol'),
                    dataField: "index",
                    width: 50,
                    allowEditing: false,
                    fixed: true
                },
                {
                    caption: $translate.instant('AssetNumber'),
                    dataField: "assetNumber",
                    width: 120,
                    allowEditing: false,
                    fixed: true
                },
                {
                    caption: $translate.instant('AssetGroupName'),
                    dataField: "assetGroupName",
                    width: 120,
                    allowEditing: false,
                    fixed: true
                },
                {
                    caption: $translate.instant('AssetDescription'),
                    dataField: "assetDescription",
                    width: 200,
                    allowEditing: false,
                    fixed: true
                },
                {
                    caption: $translate.instant('AccountData'), alignment: 'center',
                    columns: [
                        {
                            caption: $translate.instant('BuyDate'),
                            dataField: "buyDate",
                            dataType: "date",
                            format: "yyyy-MM-dd",
                            width: 100,
                            allowEditing: false
                        },
                        {
                            caption: $translate.instant('DepreciationDate'),
                            dataField: "depreciationDate",
                            dataType: "date",
                            format: "yyyy-MM-dd",
                            width: 100,
                            allowEditing: false
                        },
                        {
                            caption: $translate.instant('DepreciationPeriod'),
                            dataField: "depreciationPeriod",
                            format: {type: 'fixedPoint', precision: 0},
                            width: 100,
                            allowEditing: false
                        },
                        {
                            caption: $translate.instant('AcquisitionValue'),
                            dataField: "accountAcquisitionValue",
                            format: {type: 'fixedPoint', precision: 2},
                            width: 100,
                            allowEditing: false
                        },
                        //{ caption: $translate.instant('AdjustmentValue'), dataField: "adjustmentValue", format: { type: 'fixedPoint', precision: 2 } },
                        {
                            caption: $translate.instant('DisposedDate'),
                            dataField: "disposedDate",
                            dataType: "date",
                            format: "yyyy-MM-dd",
                            width: 100,
                            allowEditing: false
                        },
                        {
                            caption: $translate.instant('ResidualRate'),
                            dataField: "residualRate",
                            // format: {type: 'percent', precision: 2},
                            format: {type: 'fixedPoint', precision: 2},
                            width: 80,
                            allowEditing: false
                        },
                        {
                            caption: $translate.instant('PerMonthDepreciationAmount'),
                            dataField: "accountMonthDepreciationAmount",
                            format: {type: 'fixedPoint', precision: 2},
                            width: 100,
                            allowEditing: false
                        },
                        {
                            caption: $translate.instant('YearDepreciationAmount'),
                            dataField: "accountYearDepreciationAmount",
                            format: {type: 'fixedPoint', precision: 2},
                            width: 100,
                            allowEditing: false
                        },
                        {
                            caption: $translate.instant('AccountTotalepreciationAmount'),
                            dataField: "accountTotalDepreciationAmount",
                            format: {type: 'fixedPoint', precision: 2},
                            width: 100,
                            allowEditing: false
                        },
                        {
                            caption: $translate.instant('YearEndValue'),
                            dataField: "yearEndValue",
                            format: {type: 'fixedPoint', precision: 2},
                            width: 100,
                            allowEditing: false
                        },
                    ]
                },
                {
                    caption: $translate.instant('TaxData'), alignment: 'center',
                    columns: [
                        {
                            caption: $translate.instant('TaxGroupType'),
                            dataField: "taxGroupName",
                            width: 200,
                            allowEditing: false
                        },
                        {
                            caption: $translate.instant('DepreciationPeriod'),
                            dataField: "taxDepreciationPeriod",
                            format: {type: 'fixedPoint', precision: 0},
                            width: 100,
                            allowEditing: true
                        },
                        {
                            caption: $translate.instant('TaxToLastYearDepreciationPeriod'),
                            dataField: "taxToLastYearDepreciationPeriod",
                            format: {type: 'fixedPoint', precision: 0},
                            width: 150,
                            allowEditing: false
                        },
                        {
                            caption: $translate.instant('TaxToCurrentYearDepreciationPeriod'),
                            dataField: "taxToCurrentYearDepreciationPeriod",
                            format: {type: 'fixedPoint', precision: 0},
                            width: 150,
                            allowEditing: false
                        },
                        {
                            caption: $translate.instant('TaxYearDepreciationPeriod'),
                            dataField: "taxYearDepreciationPeriod",
                            format: {type: 'fixedPoint', precision: 0},
                            width: 100,
                            allowEditing: false
                        },
                        {
                            caption: $translate.instant('PerMonthDepreciationAmount'),
                            dataField: "taxMonthDepreciationAmount",
                            format: {type: 'fixedPoint', precision: 2},
                            width: 100,
                            allowEditing: false
                        },
                        {
                            caption: $translate.instant('YearDepreciationAmount'),
                            dataField: "taxCurrentYearDepreciationAmount",
                            format: {type: 'fixedPoint', precision: 2},
                            width: 100,
                            allowEditing: false
                        },
                        {
                            caption: $translate.instant('AccountTotalepreciationAmount'),
                            dataField: "taxToCurrentYearDepreciationAmount",
                            format: {type: 'fixedPoint', precision: 2},
                            width: 100,
                            allowEditing: false
                        },
                    ]
                },
                {
                    caption: $translate.instant('AssetDifferent'), alignment: 'center',
                    columns: [
                        {
                            caption: $translate.instant('TotalDifferenceAmount'),
                            dataField: "totalDifferenceAmount",
                            format: {type: 'fixedPoint', precision: 2},
                            width: 100,
                            allowEditing: false
                        },
                        {
                            caption: $translate.instant('YearDifferenceAmount'),
                            dataField: "yearDifferenceAmount",
                            format: {type: 'fixedPoint', precision: 2},
                            width: 100,
                            allowEditing: false
                        },
                    ]
                },
                {
                    caption: $translate.instant('IsRetain'),
                    alignment: 'center',
                    dataField: "isRetain",
                    dataType: "boolean",
                    width: 120,
                    allowEditing: true
                },
            ];

            $scope.assetsResultGridOptions = {
                columns: dupColumns,
                bindingOptions: {
                    "dataSource": "assetsResultData",
                },
                editing: {
                    mode: "batch",
                    allowUpdating: true,
                },
                onInitialized: function (e) {
                    $scope.dataGridInstance = e.component;
                },
                onCellPrepared: function (e) {
                    if (e.rowType === "header") {

                        if (e.column.caption === $translate.instant('ImportErrorPopUpNoCol') ||
                            e.column.caption === $translate.instant('AssetNumber') ||
                            e.column.caption === $translate.instant('AssetGroupName') ||
                            e.column.caption === $translate.instant('AssetDescription')) {
                            e.cellElement.addClass('herder-center');
                            e.cellElement.append($compile(inputElement)($scope));
                        }
                        if (e.column.caption === $translate.instant('IsRetain')) {
                            e.cellElement.empty();
                            var inputElement = $('<input type="checkbox" ng-model="SelectAll" ng-click="selectAllAsset()">{{\'isRetainDifference\' | translate}}</input>');
                            e.cellElement.addClass('herder-center');
                            e.cellElement.append($compile(inputElement)($scope));
                        }
                        if (e.column.caption === $translate.instant('IsRetain')) {
                            e.cellElement.empty();
                            var inputElement = $('<input type="checkbox" ng-model="SelectAll" ng-click="selectAllAsset()">{{\'isRetainDifference\' | translate}}</input>');
                            e.cellElement.addClass('herder-center');
                            e.cellElement.append($compile(inputElement)($scope));
                        }
                    }
                },
                loadPanel: {
                    enabled: true
                },
                paging: {
                    pageSize: 100,
                },
                searchPanel: {
                    visible: true,
                    width: 240,
                    placeholder: $translate.instant('SearchPlaceholder')
                },
                showBorders: true,
                hoverStateEnabled: true,
                //scrolling: { mode: "virtual" },
                noDataText: $translate.instant('AccountVoucher_DataGrid_NoDataText'),
                height: '99%',
                // filterRow: {
                //     visible: true
                // },
                onRowUpdating: function (e) {
                    var data = $.extend({}, e.oldData, e.newData);
                    if (data.isRetain == true) {
                        data.isRetain = 1;
                    } else if (data.isRetain == false) {
                        data.isRetain = 0;
                    }
                    targetArray.push(data);
                },
                onToolbarPreparing: function (e) {
                    e.toolbarOptions.items.unshift({
                        location: "after",
                        template: "totalGroupCount"
                    });
                    var toolbarItems = e.toolbarOptions.items;
                    var savebutton = _.find(e.toolbarOptions.items, function (m) {
                        return m.name === "saveButton"
                    });
                    var defaultFun = savebutton.options.onClick;
                    var saveAsset = function () {
                        defaultFun();
                        assetListService.updateAssetResultList(targetArray, projectId).success(function (data) {
                            if (data) {
                                getAssetResultList($scope.displayType - 1);
                                SweetAlert.success($translate.instant('SaveSuccess'));
                                targetArray = [];
                            } else {
                                SweetAlert.error(serviceErrorMsg);
                                targetArray = [];
                            }
                        }).error(function () {
                            SweetAlert.error(serviceErrorMsg);
                            targetArray = [];
                        });
                    }
                    savebutton.options.onClick = saveAsset;
                }
            }
        }

        //税会差异选项内容
        $scope.applyFilterTypes = [{
            key: "2",
            name: $translate.instant('AllTheItems')
        }, {
            key: "0",
            name: $translate.instant('TaxDepreciation') + "<" + $translate.instant('AccountDepreciation')
        }, {
            key: "1",
            name: $translate.instant('TaxDepreciation') + ">=" + $translate.instant('AccountDepreciation')
        }];
        //初始化税会差异选项
        $scope.taxAccountDifferenceOptions = {
            items: $scope.applyFilterTypes,
            value: $scope.applyFilterTypes[0].key,
            valueExpr: "key",
            displayExpr: "name",
            onValueChanged: function (data) {

                $scope.citAssetsListDto.taxAccountCompare = data.value;
                $scope.taxAccountDifferenceOptions.value = data.value;
                getAssetResultList($scope.displayType - 1);
            }
        };

        //获取数据服务
        var getGroupList = function () {

            var deferred = $q.defer();
            assetListService.getAssetGroupListData().success(function (data) {

                if (data.data) {
                    $scope.groupListDataSource = data.data;
                    deferred.resolve(data.data);
                }
            }).error(function (ex) {
                $log.error(ex);
                SweetAlert.error(serviceErrorMsg);
            });
            return deferred.promise;
        };

        //获取导入后数据
        var getGroupDetailList = function () {

            var deferred = $q.defer();
            assetListService.getAssetDetailGroupListData().success(function (data) {

                if (data.data) {
                    $scope.detailGroupListDataSource = data.data;
                    deferred.resolve(data.data);
                }
            }).error(function (ex) {
                $log.error(ex);
                SweetAlert.error(serviceErrorMsg);
            });
            return deferred.promise;
        };

        //验证分类信息是否分类完毕
        var validationAssetGroupList = function () {
            var isOk = true;
            _.each($scope.assetGroupResultDataSource, function (m) {
                if (PWC.isNullOrEmpty(m.assetName)
                    || PWC.isNullOrEmpty(m.assetGroupId)
                    || PWC.isNullOrEmpty(m.assetDetailGroupId)
                    || PWC.isNullOrEmpty(m.taxDepreciationPeriod)) {
                    isOk = false;
                }
            });
            return isOk;
        }

        //选中所有行操作
        $scope.selectAllAsset = function () {
            var isRetain = 0;
            if ($scope.SelectAll) {
                isRetain = 1;
                $scope.assetsResultData.forEach(function (m) {
                    m.isRetain = 1;
                });
            } else {
                isRetain = 0;
                $scope.assetsResultData.forEach(function (m) {
                    m.isRetain = 0;
                });
            }
            assetListService.batchUpdateIsRetain($scope.displayType - 1, projectId, isRetain);
        };

        //验证信息
        $scope.openTab = function (errorType, rowdata) {
            var data = JSON.parse(rowdata);
            if (errorType === 110) {
                dispalyDiffDataValidation(data);
            }
        }

        //显示本年与上年数据差异界面
        var dispalyDiffDataValidation = function (data) {
            //$scope.devgridDataSource = data;
            $scope.gridPeriodOptions = {
                columnAutoWidth: true,
                columns: [
                    {caption: $translate.instant('AssetNumber'), dataField: "AssetNumber", textalign: "center"},
                    {caption: $translate.instant('LastYear'), dataField: "LastYear", textalign: "center"},
                    {
                        caption: $translate.instant('LastAcquisitionValue'), dataField: "LastAcquisitionValue",
                        textalign: "right", format: {type: 'fixedPoint', precision: 2}
                    },
                    {caption: $translate.instant('CurrentYear'), dataField: "CurrentYear", textalign: "center"},
                    {
                        caption: $translate.instant('CurrentAcquisitionValue'), dataField: "CurrentAcquisitionValue",
                        textalign: "right", format: {type: 'fixedPoint', precision: 2}
                    }
                ],
                dataSource: data,
                hoverStateEnabled: true,
                loadPanel: {
                    enabled: true
                },
                paging: {
                    pageSize: 20
                },
            };

            $scope.validateModalInstance = $uibModal.open({
                animation: false,
                backdrop: 'static',
                keyboard: false,
                ariaLabelledBy: 'modal-title',
                ariaDescribedBy: 'modal-body',
                templateUrl: 'set-asset-validate-modal.html',
                scope: $scope,
                windowClass: "period-validation-modal"
            });
        }

        //关闭验证详细页面
        $scope.cancelValidateAsset = function () {
            if ($scope.validateModalInstance) {
                $scope.validateModalInstance.close();
            }
        }

        //日志
        $scope.showOperateLogPop = function () {
            $scope.isShowLog = true;
        };

        //显示验证信息
        $scope.toggleErrorTab = function () {
            $scope.ImportErrorTag = !$scope.ImportErrorTag;

            // topIcon and content-resize gapBottom 15px
            if (!$scope.ImportErrorTag) {
                setErrorWrapCssDefault();
            } else {

                if (parseInt($('#content-resizer').css('bottom')) < 100) {
                    $('#content-resizer').css('bottom', '150px');
                    $('#content-resizer').css('z-index', '2');
                    $('#topIcon').css({bottom: '-200px'});
                    $('.error-info-wrapper').css('height', '150px');
                }
            }
        };

        $scope.getGridHeight = function () {
            if ($scope.isLoadComplete) {
                return {height: ($('.balance-ouput-grid-wrapper').height() - 20) + "px"};
            } else {
                return {height: 0 + "px"};
            }
        };

        $scope.getErrorGridHeight = function () {
            if ($scope.isLoadComplete) {
                var y = $("#error-info-wrapper").height();
                // Enough space
                if (y > constant.UIGrid.gapHeight) {
                    y = y - constant.UIGrid.gapHeight;
                    return {height: y + "px"};
                } else {

                    return {height: '0px'};
                }
            }
            return {};
        };

        //显示图标
        $scope.errorLevelToString = function (errorLevel) {
            if (errorLevel === 0) {
                return '/app-resources/images/vat/error.png';
            }
            if (errorLevel === 1) {
                return '/app-resources/images/vat/warning.png';
            }
            if (errorLevel === 2) {
                return '/app-resources/images/vat/tips.png';
            } else {
                return '/app-resources/images/vat/tips.png';
            }
        }

        //切换tab
        $scope.switchTab = function (event, type) {
            $('.nav-tab span').each(function () {
                $(this).removeClass('active');
            });
            $(event.target).addClass('active');
            if ($scope.displayType !== type) {
                $scope.displayType = type;
                if (type > 1) {
                    getAssetResultList($scope.displayType - 1);
                } else {
                    $scope.assetImportGridInstance.refresh();
                }
            }
        };

        //弹出分类界面，1、先获取asset_group_result表中的数据，并赋值给数据集assetGroupResultDataSource
        $scope.setAssetsGroup = function () {
            assetListService.getAssetGroupResultData(projectId).success(function (groupResultData) {
                var data = groupResultData.data;
                if (data) {
                    var index = 1;
                    data.forEach(function (v) {
                        v.index = index++;
                    });
                    //orgAssetGroupList = angular.copy(data);
                    $scope.assetGroupResultDataSource = data;
                }
                //初始化资产分类Grid
                InitGrid(true);
                //此值传入后台用来分辨当前是导入文件时的保存资产分类或者是直接点击资产分类按钮保存资产分类
                $scope.saveGroupType = 2;
                $scope.isDisabled = false;
                $scope.modalInstance = $uibModal.open({
                    animation: false,
                    backdrop: 'static',
                    keyboard: false,
                    ariaLabelledBy: 'modal-title',
                    ariaDescribedBy: 'modal-body',
                    templateUrl: 'set-asset-group-modal.html',
                    scope: $scope,
                    windowClass: "set-asset-list-modal"
                });
            }).error(function (ex) {
                $log.error(ex);
                SweetAlert.error(serviceErrorMsg);
            });
        };

        //保存分类信息
        $scope.saveAssetGroupInfo = function () {

            var dataGrid = $('#assetsGroupGrid').dxDataGrid("instance");
            dataGrid.saveEditData();
            if (validationAssetGroupList()) {
                assetListService.saveAssetGroupInfo($scope.assetGroupResultDataSource, $scope.saveGroupType, projectId).success(function (data) {

                    if (data.data) {
                        SweetAlert.success($translate.instant('SaveSuccess'));
                        if ($scope.modalInstance) {
                            $scope.modalInstance.close();
                        }
                    } else {
                        SweetAlert.error("设置二级分类失败，请联系系统管理员");
                        if ($scope.modalInstance) {
                            $scope.modalInstance.close();
                        }
                    }
                }).error(function () {
                    SweetAlert.error(serviceErrorMsg);
                });
            } else {
                ackMessageBox.warning($translate.instant('PleaseSetAssetGroupInfo'));
            }
        };

        //关闭弹出框
        $scope.cancelAsset = function () {
            if ($scope.modalInstance) {
                $scope.modalInstance.close();
            }
        };

        //是否显示星号
        $scope.isNeedMappingColumn = function (col) {
            if ($scope.mustMappingTotalColumns.indexOf(col) > -1) {
                return true;
            } else {
                return false;
            }
        }

        //验证信息数据源
        $scope.gridOptionsErrorMsg = {
            rowHeight: constant.UIGrid.rowHeight,
            selectionRowHeaderWidth: constant.UIGrid.selectionRowHeaderWidth,
            enableSorting: false,
            enableColumnMenus: false,
            enableHorizontalScrollbar: uiGridConstants.scrollbars.enableHorizontalScrollbar,
            enableVerticalScrollbar: uiGridConstants.scrollbars.enableVerticalScrollbar,
            columnDefs: [
                {
                    name: $translate.instant('Icon'),
                    width: '5%',
                    cellTemplate: '<div class="ui-grid-cell-contents"><span><img data-ng-src="{{grid.appScope.errorLevelToString(row.entity.errorLevel)}}"><span></div>'
                },
                {
                    name: $translate.instant('SequenceNo'),
                    width: '5%',
                    cellTemplate: '<div class="ui-grid-cell-contents"><span>{{row.entity.index}}<span></div>'
                },
                {
                    name: $translate.instant('ErrorResult'),
                    width: '20%',
                    cellTemplate: '<div class="ui-grid-cell-contents"><span>{{row.entity.validationResult}}<span></div>'
                },
                {
                    name: $translate.instant('ErrorCount'),
                    width: '10%',
                    cellTemplate: '<div class="ui-grid-cell-contents"><span>{{row.entity.number}}<span></div>'
                },
                {
                    name: $translate.instant('ErrorDetail'), width: '35%', cellTemplate: dealDetail,
                },
                {
                    name: $translate.instant('ValidationTips'),
                    width: '25%',
                    cellTemplate: '<div class="ui-grid-cell-contents" title="{{row.entity.validationTips}}"><span>{{row.entity.validationTips}}<span></div>'
                },
            ],
            onRegisterApi: function (gridApi) {
                $scope.errorGridApi = gridApi;

                $interval(function () {
                    $scope.errorGridApi.core.handleWindowResize();
                }, 500, 60 * 60 * 8);
            }
        };

        //控制明细信息中删除权限
        var getUserPermission = function () {

            var list = [];
            $scope.editCode = constant.citPermission.dataImport.assetList.importCode;
            list.push($scope.editCode);
            $scope.hasEditPermission = false;
            $scope.$root.checkUserOrganizationPermissionList(list).success(function (data) {

                $scope.hasEditPermission = data[$scope.editCode];
                //$scope.dataGridInstance.option("editing.allowUpdating", $scope.hasEditPermission);
                //$scope.dataGridInstance.refresh();
                //$scope.assetGroupGridInstance.option("editing.allowUpdating", $scope.hasEditPermission);
                //$scope.assetGroupGridInstance.refresh();

            });
        };

        var initParamFilter = function () {
            $scope.citAssetsListDto.taxAccountCompare = 2;
            $scope.citAssetsListDto.assetGroupName = 2;
            $scope.citAssetsListDto.depreciationPeriod = 2;
            $scope.citAssetsListDto.taxGroupType = 2;
        };

        var doDataFilter = function () {

            // initParamFilter();
            getAssetResultList($scope.citAssetsListDto.assetType);

        }

        var doDataFilterReset = function () {

            // initParamFilter();
            $scope.citAssetsListDto.taxAccountCompare = 2;
            $scope.citAssetsListDto.assetGroupName = null;
            $scope.citAssetsListDto.depreciationPeriod = null;
            $scope.citAssetsListDto.taxGroupType = null;
            getAssetResultList($scope.citAssetsListDto.assetType);

        };

        //开始
        (function initialize() {

            /**************************************** function start*************************************************/
            $scope.displayType = 2;
            $scope.saveGroupType = 1;
            $scope.isDisabled = false;
            $scope.selectedColumnMap = [];
            $scope.incomeInvoiceTotalColumns = [];
            $scope.initIncomeInvoiceTotalColumnsIndex = [];
            $scope.changeSheet = changeSheet;
            $scope.doDataFilter = doDataFilter;
            $scope.doDataFilterReset = doDataFilterReset;

            function init() {

                initColumns();
                initDxGrid();
                initAssetResultDxGrid();
                // getAssetResultList(1);
                $scope.refreshAssetResultListGrid();

                getGroupList();
                getGroupDetailList();
                getUserPermission();
            }

            init();
            $scope.pagingService.populatePagingSelection();
            // $scope.$watch('fileNameWrapper', function (newValue, oldValue) {
            //     if (newValue != null && newValue !== oldValue) {
            //         //设置上传文件名
            //         var arr = newValue.name.split('.');
            //         if (arr[arr.length - 1] !== 'xls' && arr[arr.length - 1] !== 'xlsx' && arr[arr.length - 1] !== 'xlsm') {
            //             SweetAlert.warning($translate.instant('ImportFileInvalidType'));
            //             return;
            //         }
            //         $scope.fileName = newValue.name;
            //         uploadfile($scope.fileNameWrapper);
            //         $scope.ImportErrorTab = false;
            //         $scope.ImportErrorTag = false;
            //         $('#StartRowNum').val('2');
            //     }
            // });

            // $timeout(function () {
            //     if ($scope.dataGridInstance)
            //     {
            //         $scope.dataGridInstance.option("editing.allowUpdating", $scope.hasEditPermission);
            //         $scope.dataGridInstance.refresh();
            //     }
            // }, 1000);

        })();
    }
]);