﻿vatModule.controller('citAssetEamMappingController', ['$rootScope','$scope', '$log', '$filter','$translate', '$timeout', 'SweetAlert', '$q', 'uiGridConstants', '$interval', 'citPreviewService', 'citReportService','browserService', 'vatSessionService', 'region', 'enums', 'vatExportService',
    function ($rootScope,$scope, $log,$filter, $translate, $timeout, SweetAlert, $q, uiGridConstants, $interval, citPreviewService, citReportService, browserService, vatSessionService, region, enums, vatExportService) {
        'use strict';

        $scope.startDate = new Date(vatSessionService.project.year, 0, 1);
        $scope.endDate = new Date(vatSessionService.project.year, 11, 31);
        $scope.dateFormat = $translate.instant('dateFormat4Year');
        $scope.startMonth = vatSessionService.month;
        $scope.endMonth = vatSessionService.month;
        $scope.totalMoneyAmount = 0;
        $scope.totalTaxAmount = 0;

        var minDate = [1, vatSessionService.project.year];
        // var minDate = moment().startOf('month').subtract(0, 'months');
        var maxDate = [12, vatSessionService.project.year];
        var setDate = [
            [vatSessionService.project.year],
            [vatSessionService.project.year]];

        //初始化期间
        var initPeriods = function () {
            var curMonth = new Date().getMonth() + 1;

            $scope.queryParams = {
                pageInfo: {},
                periodStart: '',
                periodEnd: '',
                subjectCode: null,
                subjectName: null,
                orgCode: null,
                orgName: null,
                documentDate: null,
                projectId: vatSessionService.project.id
            };
        };

        //从数据库中load数据
        var loadJournalEntryDataFromDB = function () {
            //初始化查询信息
            $scope.queryParams.pageInfo = {
                totalCount: $scope.pagingOptions.totalItems,
                pageIndex: $scope.pagingOptions.pageIndex,
                pageSize: $scope.pagingOptions.pageSize,
                totalPage: 0
            };
            $scope.getDataFromDatabase($scope.queryParams);
        };

        $scope.getDataFromDatabase = function (queryParams){
            citReportService.getAssetEamMappings(queryParams).success(function (resp) {

                if (resp.data) {
                    // minDate = data.
                    var index = 1;
                    resp.data.list.forEach(function (v) {
                        v.index = index++;
                    });
                    // $scope.gridOptions.data = resp.data.list;
                    $scope.gridDataSource = resp.data.list;

                    $scope.pagingOptions.totalItems = resp.data.total;
                }
            });
        };

        //将选择了的查询条件显示在grid上方
        var doDataFilter = function (removeData) {
            if ($scope.queryParams.periodStart > $scope.queryParams.periodEnd) {
                $scope.queryParams.periodEnd = $scope.queryParams.periodStart;
            }

            //设置需要去掉的查询条件的值为空
            if (!PWC.isNullOrEmpty(removeData)) {
                var removeItem = removeData.split("|");
                removeItem.forEach(function (v) {
                    $scope.queryParams[v] = null;

                    if ($scope.queryParams.subjectCode === null) {
                        $scope.queryParams.subjectCode = '';
                    }
                    if ($scope.queryParams.subjectName === null) {
                        $scope.queryParams.subjectName = '';
                    }
                    if ($scope.queryParams.orgCode === null) {
                        $scope.queryParams.orgCode = '';
                    }
                    if ($scope.queryParams.orgName === null) {
                        $scope.queryParams.orgName = '';
                    }
                    if ($scope.queryParams.documentDate === null) {
                        $scope.queryParams.documentDate = '';
                    }
                });
            }

            loadJournalEntryDataFromDB();
            $('.filter-button').popover("hide");
        };

        //去掉所有的查询条件，重新load数据
        var doDataFilterReset = function () {
            $scope.queryParams = {
                pageInfo: {},
                periodStart: '',
                periodEnd: '',
                subjectCode: null,
                subjectName: null,
                orgCode: null,
                orgName: null,
                documentDate: null,
                projectId: vatSessionService.project.id
            };
            $scope.queryParams.periodStart = $scope.startMonth;
            $scope.queryParams.periodEnd = $scope.endMonth;
            loadJournalEntryDataFromDB();
            $('.filter-button').popover("hide");
        };

        var prepareSummary = function () {
            // do something before show popover
        };

        //在popover打开时执行事件
        var showPopover = function () {
            $timeout(function () {
                initDatePickers();
            }, 500);
        };

        //初始化时间控件
        var initDatePickers = function () {
            //认证开始时间
            var ele1 = $("#certificationDateStart");
            ele1.datepicker({
                startDate: $scope.startDate,
                endDate: $scope.endDate,
                language: region,
                autoclose: true,//选中之后自动隐藏日期选择框
                clearBtn: true,//清除按钮
                todayBtn: false,//今日按钮
                format: $scope.dateFormat//日期格式，详见 http://bootstrap-datepicker.readthedocs.org/en/release/options.html#format
            });
            ele1.datepicker("setDate", $scope.queryParams.certificationDateStart);
            //认证结束时间
            var ele2 = $("#certificationDateEnd");
            ele2.datepicker({
                startDate: $scope.startDate,
                endDate: $scope.endDate,
                language: region,
                autoclose: true,//选中之后自动隐藏日期选择框
                clearBtn: true,//清除按钮
                todayBtn: false,//今日按钮
                format: $scope.dateFormat//日期格式，详见 http://bootstrap-datepicker.readthedocs.org/en/release/options.html#format
            })
            ele2.datepicker("setDate", $scope.queryParams.certificationDateEnd);
        };

        var downloadJE = function () {
            citReportService.initExportAEMData($scope.queryParams).success(function (data, status, headers) {
                if(status===204){
                    SweetAlert.warning("没有数据可以下载");
                    return;
                }
                vatExportService.exportToExcel(data, status, headers, 'CIT.WP01901_固定资产');
            }).error(function () {
                SweetAlert.error($translate.instant('PleaseContactAdministrator'));
            });
        };

        $scope.startCalculateData = function () {
            citReportService.generateAssetEamMapping($scope.queryParams).success(function (data) {

                loadJournalEntryDataFromDB();
                // if(status===204){
                //     SweetAlert.warning("没有数据可以下载");
                //     return;
                // }
            }).error(function () {
                SweetAlert.error($translate.instant('PleaseContactAdministrator'));
            });
        };

        //刷新页面
        $scope.refreshConfigGrid = function () {
            loadJournalEntryDataFromDB();
        };

        (function initialize() {
            $log.debug('VatPreviewInputInvoiceController.ctor()...');

            //分页的设置
            $scope.pagingOptions = {
                pageIndex: 1,  //当前页码
                totalItems: 0,  //总数据
                pageSize: 20,  //每页多少条数据
                pageSizeString:"20"
            };

            $('#input-invoice-period-picker').focus(function () {
                $('.filter-button').popover("hide");
            });
            //初始化month-picker
            $('#input-invoice-period-picker').rangePicker({
                minDate: minDate,
                maxDate: maxDate,
                setDate: setDate,
                ConfirmBtnText: $translate.instant('Confirm'),
                CancelBtnText: $translate.instant('ButtonCancel')
            })
                .on('datePicker.done', function (e, result) {
                    //开始月份
                    var startMonth = result[0][1] * 100 + result[0][0];
                    //结束月份
                    var endMonth = result[1][1] * 100 + result[1][0];
                    $scope.startMonth = startMonth;
                    $scope.endMonth = endMonth;

                    $scope.queryParams.periodStart = startMonth;
                    $scope.queryParams.periodEnd = endMonth;
                    loadJournalEntryDataFromDB();
                });

            $scope.gridOptions = {
                bindingOptions: {
                    dataSource: 'gridDataSource'
                },
                columns: [
                    {
                        caption: $translate.instant('AssetType'),
                        dataField: "assetType",
                        width: 120,
                        calculateDisplayValue: function (data) {
                            if(data.assetType == 1){
                                return "固定资产";
                            }
                            if(data.assetType == 2){
                                return "长期待摊";
                            }
                            if(data.assetType == 3){
                                return "无形资产";
                            }
                        }
                    },
                    {caption: $translate.instant('AssetNumber'), dataField: "assetNumber",width: 120},
                    {caption: $translate.instant('AssetName'), dataField: "assetDescription",width: 200},
                    {caption: $translate.instant('BuyDate'), dataField: "buyDate", dataType: "date", format: "yyyy-MM-dd",width: 100},
                    {
                        caption: $translate.instant('DisposedDate'),
                        dataField: "disposedDate",
                        dataType: "date",
                        format: "yyyy-MM-dd",
                        width: 100
                    },
                    {caption: $translate.instant('AssetGroupName'), dataField: "assetGroupName",width: 120},
                    {
                        caption: $translate.instant('AcquisitionValue'),
                        dataField: "acquisitionValue",
                        format: {type: 'fixedPoint', precision: 2},
                        width: 100
                    },
                    {
                        caption: $translate.instant('ResidualRate'),
                        dataField: "residualRate",
                        format: {type: 'fixedPoint', precision: 2},
                        width: 100
                    },
                    {
                        caption: $translate.instant('YearEndValue'),
                        dataField: "yearEndValue",
                        format: {type: 'fixedPoint', precision: 2},
                        width: 100
                    },
                    {
                        caption: $translate.instant('compensationSaleAmount'),
                        dataField: "compensationSaleAmount",
                        format: {type: 'fixedPoint', precision: 2},
                        width: 100
                    },
                    {
                        caption: $translate.instant('DisposalProfitAndLoss'),
                        dataField: "disposalProfitAndLoss",
                        format: {type: 'fixedPoint', precision: 2},
                        width: 100
                    },
                    {caption: $translate.instant('TaxGroupName '), dataField: "taxGroupName"},
                    {
                        caption: $translate.instant('DepreciationPeriod'),
                        dataField: "depreciationPeriod",
                        format: {type: 'fixedPoint', precision: 0},
                        width: 100
                    },
                    {
                        caption: $translate.instant('TaxMonthDepreciationAmount'),
                        dataField: "taxMonthDepreciationAmount",
                        format: {type: 'fixedPoint', precision: 2},
                        width: 100
                    },
                    {
                        caption: $translate.instant('TaxToCurrentYearDepreciationPeriod'),
                        dataField: "taxToCurrentYearDepreciationPeriod",
                        format: {type: 'fixedPoint', precision: 0},
                        width: 100
                    },
                    {
                        caption: $translate.instant('AccountTotalepreciationAmount'),
                        dataField: "taxToCurrentYearDepreciationAmount",
                        format: {type: 'fixedPoint', precision: 2},
                        width: 100
                    },
                    {
                        caption: $translate.instant('TaxNetValue'),
                        dataField: "taxNetValue",
                        format: {type: 'fixedPoint', precision: 2},
                        width: 100
                    },
                    {
                        caption: $translate.instant('DisposalTaxBenefit'),
                        dataField: "disposalTaxBenefit",
                        format: {type: 'fixedPoint', precision: 2},
                        width: 100
                    }
                ],
                // onContentReady: function (e) {
                //     $scope.extractFinancialInstance = e.component;
                //     var totalCount = e.component.totalCount();
                //     if (totalCount > 0) {
                //         $scope.totalCount = totalCount;
                //     }
                // },
                loadPanel: {
                    enabled: true
                },
                selection: {
                    mode: "single"
                },
                paging: {
                    pageSize: 20
                },
                allowColumnResizing: true,
                showRowLines: true,
                showColumnLines: true,
                rowAlternationEnabled: true,  //单双行颜色
                showBorders: true,
                hoverStateEnabled: true,
                height: '99%',
                noDataText: $translate.instant('NoDataText'),
            };

            $scope.doDataFilter = doDataFilter;
            $scope.doDataFilterReset = doDataFilterReset;
            $scope.prepareSummary = prepareSummary;
            $scope.showPopover = showPopover;
            $scope.downloadJE = downloadJE;

            initPeriods();
            //初始化查询条件-期间范围
            $scope.queryParams.periodStart = vatSessionService.year * 100 + vatSessionService.month;
            $scope.queryParams.periodEnd = vatSessionService.year * 100 + vatSessionService.month;
            $scope.queryParams.organizationId = vatSessionService.project.organizationID;
            if($rootScope.currentLanguage === 'en-us'){
                $('.periodInput')[0].style.left = "280px";
            }else{
                $('.periodInput')[0].style.left = "150px";
            }
            loadJournalEntryDataFromDB();
        })();
    }
]);




